/*
	Плагин сделал Shidla [SGC] специально для тех, кого достала школоло не читающая правила)))
	ICQ: 312-298-513
	
	Shidla [SGC] | 2010 год
	
	2.4 [beta version]
*/

#include <amxmodx>
#include <cstrike>
#include <fakemeta>

// Пропускать проверку для админов или нет
#define Skip_Admin									
#if defined Skip_Admin
	// Если пропускать, то с каким флагом доступа
    #define AdminAccess ADMIN_KICK
#endif

new g_Rules[33], g_SpeedTaken[33]
new CVAR_SpectUser, CVAR_PlugEnable, CVAR_NoDamage, CVAR_Glow, CVAR_SetInfo, CVAR_KnifeOnly, g_msgScreenFade
new Float:UserSpeed[33]

// Поле провеяемое при режиме работы через SetInfo
new const RulesSetInfoKey[] = "_rules"

public plugin_init()
{
	// Регистрируем плагин
	register_plugin("Server Rules", "2.4b", "Shidla")

	// Региситрируем квар - переводить игрока в наблюдатели или нет при выводе правил
	CVAR_SpectUser = register_cvar("amx_spect_user", "1")

	// Региситрируем квар - включение и выключение плагина
	CVAR_PlugEnable = register_cvar("amx_rules_enable", "1")

	// Региситрируем квар - включать бессмериме для для живых и ничего не нажавших
	CVAR_NoDamage = register_cvar("amx_rules_nodamage", "1")

	// Региситрируем квар - блестеть игроку или нет
	CVAR_Glow = register_cvar("amx_rules_glow", "1")

	// Региситрируем квар - разрешить только нож?
	CVAR_KnifeOnly = register_cvar("amx_rules_knife", "1")
	
	// Проверка через setinfo
	CVAR_SetInfo = register_cvar("amx_rules_setinfo", "0")

	// Регистируем файл языков
	register_dictionary("Server_Rules.txt");

	g_msgScreenFade = get_user_msgid("ScreenFade")

	// Для поиска в инете: http://www.game-monitor.com/search.php?search=Shidla_ServerRules_v24b&type=variable&location=all&game=cstrike&x=52&y=18&num=30
	static WebStat[30]
	formatex(WebStat, charsmax(WebStat), "Server Rules v2.4 [beta] by Shidla")
	register_cvar("Shidla_ServerRules_v24b", WebStat, FCVAR_SERVER|FCVAR_SPONLY)	
}

public client_putinserver(id)
{
	// Если игрок админ, то ему присваивается значение "true", как буд-то он прочитал правила
	#if defined Skip_Admin
		if ((get_user_flags(id) & AdminAccess))
			{
			g_Rules[id] = true
			return PLUGIN_CONTINUE
			}
		g_Rules[id] = false
	#endif

	// Если запись через SetInfo	
	if(get_pcvar_num(CVAR_SetInfo))
		{
		// Берем значение из "RulesSetInfoKey"
		new RulesSetInfo[32]
		get_user_info(id, RulesSetInfoKey, RulesSetInfo, 31)
		// Проверяем на запись всякой лабуды там
		if(strlen(RulesSetInfo) > 0)
			{
			g_Rules[id] = true
			return PLUGIN_CONTINUE
			}
		set_task(1.0, "CheckUserRulesStats", id, "", 0, "b", 0)
		}

	// Присваиваем игроку значение "false"
	g_Rules[id] = false
	g_SpeedTaken[id] = false
	set_task(1.0, "CheckUserRulesStats", id, "", 0, "b", 0)
	return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
	// Присваиваем игроку значение "false"
	g_Rules[id] = false
	g_SpeedTaken[id] = false
}

public CheckUserRulesStats(id) // Когда игрок заспавнился
{
	//client_print(id,print_chat,"[DEBUG] Spawned***")

	// Если плагин выключен, по ничего не происходит
	if(!get_pcvar_num(CVAR_PlugEnable))
		return;

	if(!is_user_connected(id))
		return;

	// Если игрок админ, то ему ничего не выводится
	#if defined Skip_Admin
		if ((get_user_flags(id) & AdminAccess))
			return;
	#endif

	// Если значение "false", то вывод меню
	if(!g_Rules[id])
		{
		//client_print(id,print_chat,"[DEBUG] No Read Rules!***")

		// Читаем данные из файла языка
		new TextTitle[ 555 char ];		// Заголовок
		formatex( TextTitle, charsmax( TextTitle ), "%L", LANG_PLAYER, "TITLE")
		new TextYES[ 555 char ];		// "Да"
		formatex( TextYES, charsmax( TextYES ), "%L", LANG_PLAYER, "YES")
		new TextNO[ 555 char ];		// "Нет"
		formatex( TextNO, charsmax( TextNO ), "%L", LANG_PLAYER, "NO")
		new TextRead[ 555 char ];		// "Читать"
		formatex( TextRead, charsmax( TextRead ), "%L", LANG_PLAYER, "READ")

		// Создаём меню
		new i_Menu = menu_create(TextTitle, "Rules_Menu_Options")
		menu_additem(i_Menu, TextYES, "1", 0)
		menu_additem(i_Menu, TextNO, "2", 0)
		menu_additem(i_Menu, TextRead, "3", 0)
		
		// Отображаем меню
		menu_display(id, i_Menu, 0)

		// Затемняем экран
		set_task(0.1, "ScreenFade", id)

		if(get_pcvar_num(CVAR_Glow))
			{
			// Заставляем модель "блестеть": по-умолчанию цвет 115_50_155 - фиалЭтовый
			fm_set_rendering(id, kRenderFxGlowShell, 115, 50, 155, kRenderNormal, 25)
			}

		// Устанавливаем проверки
		set_task(0.1, "UserMovie", (id))
		}
	return;
}


public Rules_Menu_Options(id, menu, item)
{
	new s_Data[6], s_Name[64], i_Access, i_Callback

	// Получаем данные
	new player[32]
	get_user_name(id, player, 32)
	menu_item_getinfo(menu, item, i_Access, s_Data, charsmax(s_Data), s_Name, charsmax(s_Name), i_Callback)
	new i_Key = str_to_num(s_Data)

	switch(i_Key)
    {
        case 1:
        {
			// Отмечаем прочтение правил
			g_Rules[id] = true

			// Если прописан квар записи через SetInfo, то отметить прочтение
			if(get_pcvar_num(CVAR_SetInfo))
				client_cmd(id, "setinfo %s 1", RulesSetInfoKey)

			// Удаляем затемнение
			set_task(0.1, "DelScreenFade", id)

			// Удаляем "блеск" модели
			fm_set_rendering(id)

			// Восстанавливаем скорость
			set_task(0.1, "UserMovie", (id))

			// Если есть бессметрие - убираем
			if(fm_get_user_godmode(id))
				fm_set_user_godmode(id)

			// Уничтожение меню
			if(g_Rules[id])
				menu_destroy(menu)
			return PLUGIN_HANDLED
        }
        case 2:
        {	
			// Читаем данные из файла языка
			new TextREASON[ 555 char ];		// Причина
			formatex( TextREASON, charsmax( TextREASON ), "%L", LANG_PLAYER, "REASON")
			server_cmd("kick %s %s", player, TextREASON)
        }
        case 3:
        {
			//client_print(id,print_chat,"[DEBUG] Menu Case 3***")
            
			// Удаляем "блеск" модели
			if(is_user_alive(id))
				fm_set_rendering(id)

			// Переводим за наблюдателей
			Spect_User(id);

			// Читаем данные из файла языка
			new TextURL[ 555 char ];		// Ссылка
			formatex( TextURL, charsmax( TextURL ), "%L", LANG_PLAYER, "URL")
			
			// Показываем MOTD
			show_motd(id, TextURL,"[Rules:]")
        }
    }

	//client_print(id,print_chat,"[DEBUG] Menu Func End***")
	g_Rules[id] = false

	return PLUGIN_HANDLED
}

public UserMovie(id)
{
	// Если труп и не подключён, то ничего не делать
	if(!is_user_alive(id) || !is_user_connected(id))
		return PLUGIN_CONTINUE

	// Проверка - взята ли скорость и подключён ли пользователь
	if(!g_SpeedTaken[id])
		{
			if(is_user_alive(id) & is_user_connected(id))
			{
			// Берем текущую скорость
			pev(id, pev_maxspeed, UserSpeed[id])
			// Помечаем, что скорость взята
			g_SpeedTaken[id] = true
			}
			else
			return PLUGIN_CONTINUE
		}

	// Если согласен с правилами, то вернуть всё на свои места
	if(g_Rules[id] & is_user_connected(id))
		{
		// Восстанавливаем старую скорость
		set_pev(id, pev_maxspeed, UserSpeed[id])
		return PLUGIN_CONTINUE
		}

	if(is_user_alive(id) & is_user_connected(id))
		{
		// Останавливаем движение
		set_pev(id, pev_velocity, Float:{0.0,0.0,0.0})
		// Запрещаем двигаться
		set_pev(id, pev_maxspeed, 1.0)
		}
		else
		return PLUGIN_CONTINUE

	// Разрешаем только нож
	if(get_pcvar_num(CVAR_KnifeOnly))
		{
		new CurrWeapon = read_data(2)
		if (CurrWeapon != CSW_KNIFE)
			engclient_cmd(id, "weapon_knife")
		}

	// Проверка - давать ли бессмертие
	if(get_pcvar_num(CVAR_NoDamage) & is_user_connected(id))
		{
		if(fm_get_user_godmode(id))
			return PLUGIN_CONTINUE
		fm_set_user_godmode(id, 1)
		}
	return PLUGIN_CONTINUE
}

public Spect_User(id)
{	
	if(get_pcvar_num(CVAR_SpectUser) & is_user_connected(id))
		{
		if(is_user_alive(id))
			{
			new deaths = cs_get_user_deaths(id)
			user_silentkill(id) 
			cs_set_user_deaths(id, deaths)
			}
		engclient_cmd(id, "jointeam", "6")
		engclient_cmd(id, "joinclass", "1")
		}
	return PLUGIN_CONTINUE
}

public ScreenFade(id)
{
	if(is_user_connected(id) & is_user_alive(id))
		{
		message_begin(MSG_ONE, g_msgScreenFade, _, id)
		write_short(1<<0)	// Duration
		write_short(1<<0)	// Hold time
		write_short(1<<2)	// Fade type
		write_byte(0)		// Red
		write_byte(0)		// Green
		write_byte(0)		// Blue
		write_byte(255)		// Alpha
		message_end()
		}
}

public DelScreenFade(id)
{
	if(is_user_connected(id))
		{
		message_begin(MSG_ONE, g_msgScreenFade, _, id)
		write_short(1<<0)	// Duration
		write_short(1<<0)	// Hold time
		write_short(1<<0)	// Fade type
		write_byte(0)		// Red
		write_byte(0)		// Green
		write_byte(0)		// Blue
		write_byte(0)		// Alpha
		message_end()
		}
}

// Стоки:
// Рендеринг "блеска"
stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 16)
{
	static Float:color[3]
	color[0] = float(r)
	color[1] = float(g)
	color[2] = float(b)
	
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, float(amount))
}

// Проверка на бессмертие
stock fm_get_user_godmode(index)
{
	new Float:val;
	pev(index, pev_takedamage, val);

	return (val == DAMAGE_NO);
}

// Бессмерсие
stock fm_set_user_godmode(index, godmode = 0)
{
	set_pev(index, pev_takedamage, godmode == 1 ? DAMAGE_NO : DAMAGE_AIM);

	return 1;
}